const BizResultCode = require('./BaseResultCode');

class BizResult {

    code;
    msg;
    data;
    time;

    /**
     * 
     * @param code {number} code
     * @param msg {string} msg
     * @param data {any} data
     */
    constructor(code, msg, data) {
        this.code = code;
        this.msg = msg;
        this.data = data;
        this.time = Date.now();
    }

    /**
     * success
     * @param data {any} data
     * @return {BizResult}
     */
    static success(data) {
        return new BizResult(BizResultCode.SUCCESS.code, BizResultCode.SUCCESS.desc, new BizResult(BizResultCode.SUCCESS.code, BizResultCode.SUCCESS.desc, data));
    }

    /**
     * fail
     * @param errData 
     * @return {BizResult}
     */
    static fail(bizResultCode, errData) {
        return new BizResult(BizResultCode.SUCCESS.code, BizResultCode.SUCCESS.desc, new BizResult(bizResultCode.code, bizResultCode.desc, errData));
    }

    /**
     * custom fail
     * @param errData 
     * @return {BizResult}
     */
    static customFail(bizResultCode, desc, errData) {
        return new BizResult(BizResultCode.SUCCESS.code, BizResultCode.SUCCESS.desc, new BizResult(bizResultCode.code, bizResultCode.desc + desc, errData));
    }

    /**
     * valid failed
     */
    static validateFailed(param) {
        return new BizResult(BizResultCode.SUCCESS.code, BizResultCode.SUCCESS.desc, new BizResult(BizResultCode.VALIDATE_FAILED.code, BizResultCode.VALIDATE_FAILED.desc, param));
    }
}

module.exports = BizResult